<template>
  <b-row align-v="baseline" class="mb-3 mt-3 button-bottom">
    <b-col v-for="format in formats" :key="format.value"
      class="text-center">
      <b-button variant="outline-secondary" size="sm" class="w-100"
        @click="download(format)">{{format.label}}</b-button>
    </b-col>
    <b-col v-if="formats.length==0">
      <i>Pas de service de téléchargement disponible pour cette donnée</i></b-col>
  </b-row>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/no-this-alias */
import Component from 'vue-class-component';
import BaseComponent from '@/components/BaseComponent';
import LayerConfig from '@/models/map-context/LayerConfig';
import FileSaver from 'file-saver';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
  },
})
export default class DownloadPanel extends BaseComponent {
  layer!: LayerConfig;

  formats:any=[];

  wmsFormats=[
    { value: 'image/png', label: 'PNG', type: 'WMS' },
    { value: 'image/jpeg', label: 'JPEG', type: 'WMS' }];

  wfsFormats=[
    {
      value: 'SHAPE-ZIP', label: 'SHAPE', type: 'WFS', extension: 'zip',
    },
    {
      value: 'csv', label: 'CSV', type: 'WFS', extension: 'csv',
    },
    {
      value: 'application/json', label: 'JSON', type: 'WFS', extension: 'json',
    }];

  mounted():void{
    console.log(this.layer);
    if (this.layer.isWMS()) {
      this.formats = []; // this.wmsFormats; # https://redmine.neogeo.fr/issues/12151
      const self = this;
      if (this.layer.hasWFSCapacity()) {
        this.formats = this.formats.concat(this.wfsFormats);
      }
    }
    if (this.layer.isWFS()) {
      this.formats = this.formats.concat(this.wfsFormats);
    }
    if (this.layer.type === 'Vector') {
      this.formats.push({ value: 'GEOJSON', label: 'GEOJSON', type: 'Vector' });
    }
    // TODO compare format in capabilities with list
    const self = this;
    this.capabilitiesService.getCapabilities(this.layer.getCapabilitiesUrl())
      .subscribe(
        (data:any) => {
          console.log(data);
          console.log(self);
        },
        (error:any) => {
          console.log(error);
        },
      );
  }

  download(format:any):void{
    if (this.layer.type === 'Vector' && format.value === 'GEOJSON') {
      console.log(this.layer.jsonData);
      const blob = new Blob([this.layer.jsonData],
        { type: 'text/plain;charset=utf-8' });
      FileSaver.saveAs(blob, `${this.layer.title}.geojson`);
    } else {
      const url:any = this.layer.getDownloadUrl(format);
      FileSaver.saveAs(url, `${this.layer.title}.${format.extension}`);
      // window.open(this.layer.getDownloadUrl(format), '_target=blank');
    }
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

</style>
